implementation module Char

from StdChar        import  isDigit,isUpper
from StdFunc        import  o

from PreludeList    import  length,++,!!,elem,span
from PreludeText    import  class Show(..), :: ShowS(..), :: ReadS(..), showChar, showString, shows, instance Show Int
from Numeric        import  readDec,readOct,readHex,lexDigits
from Prelude		import  ||, from_to

import charInstances
import   intInstances
// Character code functions

ord :: Char -> Int
ord c = fromChar c

chr :: Int  -> Char
chr c = toChar c

// Text functions

readLitChar :: ReadS Char
readLitChar = readLitChar_

readLitChar_ ['\\':s]    =  readEsc s
    where       
        readEsc ['a':s]  = [('\a',s)]
        readEsc ['b':s]  = [('\b',s)]
        readEsc ['f':s]  = [('\f',s)]
        readEsc ['n':s]  = [('\n',s)]
        readEsc ['r':s]  = [('\r',s)]
        readEsc ['t':s]  = [('\t',s)]
        readEsc ['v':s]  = [('\v',s)]
        readEsc ['\\':s] = [('\\',s)]
        readEsc ['"':s]  = [('"' ,s)]
        readEsc ['\'':s] = [('\'',s)]
//      readEsc ['^':c:s] | c >= '@' && c <= '_' = [(chr (ord c - ord '@'), s)] // Unicode needed
        readEsc s=:[d:_] | isDigit d    = [(chr n, t) \\ (n,t) <- readDec s]
        readEsc ['o':s]                 = [(chr n, t) \\ (n,t) <- readOct s]
        readEsc ['x':s]                 = [(chr n, t) \\ (n,t) <- readHex s]
        readEsc s=:[c:_] | isUpper c = 
            let 
                table           = [(127, ['DEL']) : assocs_ asciiTab]
                assocs_ asct    = [(i,a) \\ i <- from_to 0 (length asct - 1), a <- asct]
            in
                case [(toChar c,s`) \\ (c, mne) <- table, ([],s`) <- [match mne s]] of
                    [pr:_]  -> [pr]
                    []      -> []
        readEsc _        = []

        match :: [a] [a] -> ([a],[a])   | Eq a
        match [x:xs] [y:ys] | x == y  =  match xs ys
        match xs     ys               =  (xs,ys)

readLitChar_ [c:s]       =  [(c,s)]

showLitChar :: Char -> ShowS
showLitChar c | c > del     =  showChar '\\' o protectEsc isDigit (shows (ord c))
showLitChar d | d == del    =  showString ['\\DEL']
showLitChar '\\'            =  showString ['\\','\\']
showLitChar c | c >= ' '    =  showChar c
showLitChar '\a'            =  showString ['\\a']
showLitChar '\b'            =  showString ['\\b']
showLitChar '\f'            =  showString ['\\f']
showLitChar '\n'            =  showString ['\\n']
showLitChar '\r'            =  showString ['\\r']
showLitChar '\t'            =  showString ['\\t']
showLitChar '\v'            =  showString ['\\v']
showLitChar s | s == so     =  protectEsc ((==) 'H') (showString ['\\SO'])
showLitChar c               =  showString ['\\' : asciiTab !! (fromChar c) ]                       


protectEsc p f             = f o cont
    where
        cont s=:[c:_]   | p c   = ['\\&'] ++ s
        cont s                  = s

del =   toChar 127  // '\DEL'
so  =   toChar 14   // '\SO'

asciiTab = [['NUL'], ['SOH'], ['STX'], ['ETX'], ['EOT'], ['ENQ'], ['ACK'], ['BEL'],
            ['BS'],  ['HT'],  ['LF'],  ['VT'],  ['FF'],  ['CR'],  ['SO'],  ['SI'], 
            ['DLE'], ['DC1'], ['DC2'], ['DC3'], ['DC4'], ['NAK'], ['SYN'], ['ETB'],
            ['CAN'], ['EM'],  ['SUB'], ['ESC'], ['FS'],  ['GS'],  ['RS'],  ['US'], 
            ['SP']]

lexLitChar  :: ReadS [Char]
lexLitChar  = lexLitChar` 
    where
        lexLitChar` ['\\':s] =  [(['\\':esc], t) \\ (esc,t) <- lexEsc s]
        lexLitChar` [c:s]    =  [([c],s)]
        lexLitChar` []       =  []
        
        lexEsc [c:s]    | elem c ['abfnrtv\\\"\'']  = [([c],s)]
        lexEsc s=:[d:_] | isDigit d                 = lexDigits s
        lexEsc s=:[c:_] | isUpper c                 = [span isCharName s]
        lexEsc _                                    = []
    //  lexEsc ['^':[c:s]] | c >= '@' && c <= '_'   = [(['^',c],s)] Unicode: Very crude approximation to \XYZ.
        isCharName c = isUpper c || isDigit c
