implementation module Numeric

from StdFunc        import  o
from StdChar        import  digitToInt

from PreludeText    import  :: ReadS(..), :: ShowS(..), readParen, showParen, showChar, lex, read, class Read(..)
from PreludeList    import  span,foldl1,length,elem,++,map
from Char           import  isDigit,isOctDigit,isHexDigit
from Ratio          import  %, ::Ratio

from Prelude import negate, >, error, fromIntegral

import  intInstances
import charInstances

showSigned  :: (a -> ShowS) Int a -> ShowS  | Hs__Real a
showSigned showPos p x 
    | x < zero  = showParen (p > 6) (showChar '-' o showPos ( negate x))
                = showPos x

showInt     :: a -> ShowS   |   Integral a
showInt n 
    | n < zero  = error ['showInt: can\'t show negative numbers']
                = \r -> let 
                            (n`,d)  = quotRem n ten
                            r`      = [toEnum (fromEnum '0' + fromIntegral d) : r]
                            ten     = toEnum 10
                        in  
                            if (n` == zero) r` (showInt n` r`)

readSigned :: (ReadS a) -> ReadS a  |   Hs__Real a
readSigned readPos = readParen False read`
    where 
        read` r     = (read`` r) ++ [(negate x,t)   \\  (['-'],s) <- lex r, (x,t)   <- read`` s ]
        read`` r    = [(n,s) \\ (str,s) <- lex r,   (n,[])  <- readPos str  ]

readInt :: a (Char -> Bool) (Char -> Int) -> ReadS a | Integral a
readInt radix isDig digToInt = \s ->
    [(foldl1 (\n d -> n * radix + d) (map (fromIntegral o digToInt) ds), r)
        \\  (ds,r) <- nonnull isDig s ]

readDec :: ReadS a  | Integral a
readDec = readInt (toEnum 10) isDigit digitToInt

readOct :: ReadS a | Integral a
readOct = readInt (toEnum 8) isOctDigit digitToInt

readHex :: ReadS a | Integral a
readHex = readInt (toEnum 16) isHexDigit digitToInt

lexDigits   :: ReadS [Char]
lexDigits   =  nonnull isDigit

nonnull     :: (Char -> Bool) -> ReadS [Char]
nonnull p   = \s ->   [(cs,t) \\ (cs=:[_:_],t) <- [span p s]]
