implementation module PreludeLayer

import StdEnv

from2 :: !Int -> [Int] 
from2 n = [n : from2 (n+1)]

from_to :: !Int !Int -> [Int]
from_to n e 
    | n <= e    = [n : from_to (n+1) e]
                = []

from_then :: !Int !Int -> [Int] 
from_then n1 n2 = [n1 : from_by n2 (n2-n1)]
    where
        from_by :: Int Int -> [Int] 
        from_by n s = [n : from_by (n+s) s]

from_then_to :: !Int !Int !Int -> [Int]
from_then_to n1 n2 e    
    | n1 <= n2
        = from_by_to n1 (n2-n1) e
        = from_by_down_to n1 (n2-n1) e
    where
        from_by_to :: !Int !Int !Int -> [Int]
        from_by_to n s e
            | n<=e  = [n : from_by_to (n+s) s e]
                        = []
        from_by_down_to :: !Int !Int !Int -> [Int]
        from_by_down_to n s e
            | n>=e
                = [n : from_by_down_to (n+s) s e]
                = []

// ---------- Conflicting classes and instances used in Clean --------------
hs__abort :: ![Char] -> .a
hs__abort x = abort (toString x)

class (hs__rem) infix 7 a :: !a !a -> a
instance hs__rem Int where (hs__rem) x y = x rem y

class (hs__quot) infix 7    a :: !a !a -> a

instance hs__quot Int where (hs__quot) x y = x / y

// -----
// for PreludeIO

toStr :: [Char] -> String
toStr cs = toString cs

fromStr :: String -> [Char]
fromStr str = fromString str

// removes newline from the end of the string
removeNL :: String -> String
removeNL str = { ch \\ ch <-: str | not (ch == '\n') }

